Subject: Re: Extensibility of Commands and Descriptors

From: "Rosen, Brian" <[email-masked]>
Date: Mon, 14 Feb 2000 11:34:02 -0500

I'm not an ASN.1 hacker, but I've seen my fair share of
ABNF.  I've also had a decent night's sleep.

1. Adding more flags to EventDescriptor, like KeepActive,
is possible without any changes.  The production:
eventParameter       = ( embedOrKeepActive / eventDM / eventStream
                        / eventOther )
would be extended to add additional flags.  Note that the
embedOrKeepActive rule would probably not change unless it was
intended that you couldn't have the flag with embedded events/signals.

There are some descriptors where adding a flag may not be
quite as straigtforward, but it could be done in a backwards
compatible way.

2. Adding a new descriptor is easy; the productions for
each of the request/reply rules would be extended to add the
descriptor

3. Adding a new command is easy, the commandRequest and commandRelys
productions would be extended.

Brian

> -----Original Message-----
> From: Hascall "Chip" Sharp [mailto:[email-masked]]
> Sent: Monday, February 14, 2000 11:10 AM
> To: [email-masked]
> Subject: Extensibility of Commands and Descriptors
>
>
>
> Immediate feedback is appreciated.
>
> SG116 is currently working on final text for H.248.
> However, there is concern (mainly by me) about how
> H.248 will be extended in v2 and if it can be extended
> easily.
>
> In particular, if megaco or SG16 wants to add a new:
>         Command
>         Descriptor
>         flag or action in a descriptor
>
> And new procedures to use them, can they be added
> to v2 in a backward compatible way.  I believe
> extensions to parameters has been handled in the packages
> definition.
>
> For example, if we find we really do need an Accumulate
> action in the EventsDescriptor or a "Process" algorithm, can
> the syntax be extended in a backward compatible way.
>
> I think it can, but due to lack of sleep I can't be sure.
> I would apprciate if some of you can read through the ABNF
> and ASN.1 and make sure the syntax is extendable without major
> pain to the parsers.
>
> Thanks,
> Chip
> -------------------------------------------------------
> Chip Sharp                      voice: +1 (919) 472-3121
> Consulting Engineer             email:  [email-masked]
> Cisco Systems                   http://www.cisco.com/
> ---------------------------------------------------------
>